unit AppDieU;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
  hkKb, hkMouse: HHook;

function HookProc(HHook, Code: Integer; WParam: Cardinal; LParam: Longint): Longint;
begin
  Form1.Timer1.Enabled := False;
  Form1.Timer1.Enabled := True;
  Result := CallNextHookEx(HHook, Code, WParam, LParam)
end;

function HookProcKB(Code: Integer; WParam: Cardinal; LParam: Longint): Longint;
  {$ifdef Win32}stdcall{$else}far{$endif};
begin
  Result := HookProc(hkKB, Code, WParam, LParam)
end;

function HookProcMouse(Code: Integer; WParam: Cardinal; LParam: Longint): Longint;
  {$ifdef Win32}stdcall{$else}far{$endif};
begin
  Result := HookProc(hkMouse, Code, WParam, LParam)
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  hkKb := SetWindowsHookEx(wh_Keyboard,
    {$ifdef Win32}@{$endif}HookProcKB, HInstance,
    {$ifdef Win32}GetCurrentThreadID{$else}GetCurrentTask{$endif});
  hkMouse := SetWindowsHookEx(wh_Mouse,
    {$ifdef Win32}@{$endif}HookProcMouse, HInstance,
    {$ifdef Win32}GetCurrentThreadID{$else}GetCurrentTask{$endif});
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  UnhookWindowsHookEx(hkKb);
  UnhookWindowsHookEx(hkMouse);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Close;
end;

end.
