unit UpdateSystemFileMainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    dlgSrc: TOpenDialog;
    dlgDst: TSaveDialog;
    btnChooseSrc: TButton;
    btnChooseDst: TButton;
    lblSrc: TLabel;
    lblDst: TLabel;
    btnSetup: TButton;
    procedure btnChooseSrcClick(Sender: TObject);
    procedure btnChooseDstClick(Sender: TObject);
    procedure btnSetupClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  FileCtrl, IniFiles;

{$R *.DFM}

procedure TForm1.btnChooseSrcClick(Sender: TObject);
begin
  if dlgSrc.Execute then
  begin
    lblSrc.Caption := MinimizeName(dlgSrc.FileName,
      Canvas, btnChooseSrc.Width);
    btnChooseDst.Enabled := True;
    btnChooseDst.SetFocus
  end
end;

procedure TForm1.btnChooseDstClick(Sender: TObject);
begin
  dlgDst.InitialDir := ExtractFilePath(dlgSrc.FileName);
  if dlgDst.Execute then
  begin
    lblDst.Caption := MinimizeName(dlgDst.FileName,
      Canvas, btnChooseDst.Width);
    btnSetup.Enabled := True;
    btnSetup.SetFocus
  end
end;

procedure TForm1.btnSetupClick(Sender: TObject);
var
  Src, Dst: array[0..MAX_PATH] of Char;
begin
  case Win32Platform of
    VER_PLATFORM_WIN32_WINDOWS:
      with TIniFile.Create('WinInit.Ini') do
        try
          GetShortPathName(PChar(dlgSrc.FileName), Src, MAX_PATH);
          GetShortPathName(PChar(dlgDst.FileName), Dst, MAX_PATH);
          WriteString('rename', Dst, Src)
        finally
          Free
        end;
    VER_PLATFORM_WIN32_NT:
    begin
      Win32Check(MoveFileEx(PChar(dlgSrc.FileName),
        PChar(dlgDst.FileName),
        MoveFile_Delay_Until_Reboot))
    end
  end
end;

end.
